<!--
 -------------------------------------------------------------------------------
 MIT License

 Copyright (c) 2024 University College Cork (UCC)
 
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included in all
 copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.
  
   
 SPDX-License-Identifier: MIT
   
 Contributors:
    Panagiotis Kyziropoulos - Author
    Dimitrios Bikoulis - Co-author
 
 ------------------------------------------------------------------------------- 
-->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.4/jquery.min.js"></script>
    <title>Review Metadata</title>
    <link rel="stylesheet" href="css/styles.css">
    <link rel="stylesheet" href="//netdna.bootstrapcdn.com/bootstrap/3.0.0/css/bootstrap-glyphicons.css">
</head>
<body>
    <div class="header">
            <div class="header-container">
                <img src="images/logo.png" alt="Logo">
                <button onclick="location.href='/'">Home</button>
                <button onclick="location.href='/data-products'">Data Products</button>
                <button id="review-metadata-button" onclick="location.href='/review_metadata'">Review Metadata</button>
            </div>
    </div>
    <div id="main" class="main">
        <div id="main-review-page" class="main-container">
            <div id="json-data-container">
            </div>
            <div class="button-wrapper">
                <button id="button-publish" class="big-publish" onclick="handle_publish()"><span id="login-lock" class="glyphicon glyphicon-lock" style="margin-right: 5px;"></span>Publish to AI on Demand</button>
            </div>    
        </div>
    </div>

    <div id="popupOverlay" class="popup-overlay"></div>

    <div id="popup" class="popup">
        <span id="popupClose" class="popup-close">&times;</span>
        <div id="popupContent"></div>
    </div>


    <script>
        let mdata1, mdata2, mdata3;

        var metadata=JSON.parse(sessionStorage.getItem("metadata"));
        
        load_metadata(metadata);

        // get api details from cookie
        function getCookie(cname) {
            var name = cname + "=";
            var decodedCookie = decodeURIComponent(document.cookie);
            var ca = decodedCookie.split(';');
            for(var i = 0; i <ca.length; i++) {
                var c = ca[i];
                while (c.charAt(0) == ' ') {
                c = c.substring(1);
                }
                if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
                }
            }
            return false;
        }

        // handler to update changed values
        function change_metadata(metadata,dataset,attr,value){

            // find index 
            const index = metadata[dataset]["payload"].findIndex(item => item.attribute === attr);

            // Change metadata
            if ((metadata[dataset]["payload"][index].type) === "array"){
                const inputresult = parseEntries(value);
                metadata[dataset]["payload"][index].value=inputresult;
            }else{
                metadata[dataset]["payload"][index].value=value;
            }


            // Serialize the object to a JSON string
            const metadata_str = JSON.stringify(metadata);

            // Set the session cookie (cookie that will expire when the browser is closed)
            sessionStorage.setItem("metadata",metadata_str);
        }

        // load_metadata
        function load_metadata(data){

            const container = document.getElementById('json-data-container');
            container.innerHTML = '';
            var num=1;
            data.forEach((item) => {

                const metadata_container= document.createElement("div");
                metadata_container.className="metadata-container"

                metadata_info=create_info_div(num);

                div_element = displayJsonData(item,num);
                div_element.style.display="none";
                div_element.id="metadata"+num

                metadata_container.appendChild(metadata_info)
                metadata_container.appendChild(div_element)
                container.appendChild(metadata_container)

                num++; 
            });

            var user_obj = JSON.parse(sessionStorage.getItem("user"));
            if (user_obj !== null){
                document.getElementById("login-lock").style.visibility="hidden";
            }

        }

        // create header dataset divs
        function create_info_div(num){

            const metadata_info= document.createElement("div");
            metadata_info.className="metadata-info"

            const metadata_title_wrapper = document.createElement("div");
            metadata_title_wrapper.className = "metadata-title-wrapper"
            

            const metadata_title = document.createElement("div");
            metadata_title.className = "metadata-title"
            metadata_title.innerText = "Dataset Metadata #"+num;

            const checkbox = document.createElement('input');
            checkbox.type = 'checkbox';
            checkbox.className = "input-checkbox"
            checkbox.id = 'checkbox'+(num-1);
            checkbox.name = 'checkbox'+(num-1);
            checkbox.checked = true;

            const metadata_button = document.createElement("span");
            metadata_button.className = "glyphicon glyphicon-chevron-up"
            metadata_button.id="button"+num

            metadata_title_wrapper.appendChild(metadata_title);
            metadata_title_wrapper.appendChild(checkbox);
            metadata_info.appendChild(metadata_title_wrapper);
            metadata_info.appendChild(metadata_button);

            metadata_button.addEventListener('click', function() {
                visual(num);
            });

            return metadata_info;
        }

        // handle buttons for datasets
        function visual(num){
            if (document.getElementById("metadata"+num).style.display === "none"){
                document.getElementById("metadata"+num).style.display="block"
                document.getElementById("button"+num).className="glyphicon glyphicon-chevron-down"

            }else{
                document.getElementById("metadata"+num).style.display="none"
                document.getElementById("button"+num).className="glyphicon glyphicon-chevron-up"
            }
        }

        // Function to display the JSON data
        function displayJsonData(json,num) {

            const container = document.createElement("div");
            container.className = "metadata-box"
            const data = json.payload;
            const status = json.status;

            const groups = {};
            
            for (const item in data) {

                const key=data[item]["attribute"];

                const value = data[item]["value"];
                const isMandatory = data[item]["mandatory"];
                const type = data[item]["type"]
                const description = data[item]["description"]
                const example = data[item]["example"]

                let groupKey = 'general';
                if (key.includes('.')) {
                    groupKey = key.split('.')[0];
                }

                if (!groups[groupKey]) {
                    groups[groupKey] = [];
                }

                groups[groupKey].push({ key, value, type, isMandatory, description, example });   
            }

            for (const group in groups) {
                const groupDiv = document.createElement('div');
                groupDiv.className = 'group';

                const groupTitle = document.createElement('h2');
                groupTitle.textContent = group.replace('_', ' ').toUpperCase();
                groupDiv.appendChild(groupTitle);

                groups[group].forEach(attribute => {
                    const { key, value, type, isMandatory, description, example } = attribute;

                    const div = document.createElement('div');
                    div.className = 'attribute-container';

                    const label = document.createElement('label');

                    let keytxt=key;
                    if (key.includes('.')) {
                        let parts = key.split('.');
                        if (parts.length>2){
                            keytxt = parts[2];
                        }else{
                            keytxt = parts[1];
                        }
                    }

                    label.innerHTML=keytxt

                    if (isMandatory) {
                        label.classList.add('mandatory');
                    }

                    let input;
                    if (Array.isArray(value)) {
                        input = document.createElement('textarea');
                        input.id = "dataset-"+num+"-"+key;
                        input.rows = 7;
                        input.cols = 50;
                        
                        if (JSON.stringify(value).includes('{') && JSON.stringify(value).includes('}')) {

                            input.value = JSON.stringify(value,null,2).slice(1, -1)
                        } else {
                            input.value = value;
                        }
                        
                    } else {
                        input = document.createElement('input');
                        input.id = "dataset-"+num+"-"+key;
                        input.type = 'text';
                        input.value = typeof value === 'object' ? JSON.stringify(value) : value;
                    }

                    input.addEventListener("change", (event) => {

                        let parts = input.id.split('-');
                        let num = Number(parts[1])-1;
                        let key = parts[2];
                        let value = input.value
                        change_metadata(metadata,num,key,value)
                    });

                    description_div = document.createElement('div');
                    description_div.className = "description"
                    description_div.innerHTML = "<b>Description:</b> "+ description;

                    type_div = document.createElement('div');
                    type_div.className = "example"
                    type_div.innerHTML = "<b>Type:</b> "+ type;

                    example_div = document.createElement('div');
                    example_div.className = "example"
                    example_div.innerText = "e.g. "+ example
                    
                    div.appendChild(label);
                    div.appendChild(input);
                    div.appendChild(description_div);
                    div.appendChild(type_div);
                    div.appendChild(example_div);

                    groupDiv.appendChild(div);
                });

                container.appendChild(groupDiv);
            }
            return container;
        }

        // Function to parse JSON entries
        function parseJsonEntries(inputString) {
            // This regex matches JSON objects including nested ones
            const regex = /(\{[^]*?\})(?=\s*,|\s*$)/g;
            const matches = [];
            let match;

            while ((match = regex.exec(inputString)) !== null) {
                matches.push(match[0].trim());
            }

            // Parse each JSON entry
            const parseEntry = (entry) => {
                try {
                    const parsedJSON = JSON.parse(entry);
                    return parsedJSON;
                } catch (e) {
                    throw new Error(`Invalid JSON entry: ${entry}`);
                }
            };

            // Parse each matched entry
            return matches.map(parseEntry);
        }

        // Function to parse text and number entries
        function parseSimpleEntries(inputString) {
            // Split the input string by commas and trim whitespace from each entry
            const entries = inputString.split(',').map(entry => entry.trim());

            // Function to check if a string is a number
            const isNumber = (str) => {
                return !isNaN(str) && str.trim() !== '';
            };

            // Determine if all entries are numbers
            const allNumbers = entries.every(isNumber);

            if (allNumbers) {
                // If all entries are numbers, convert them to numbers
                return entries.map(entry => Number(entry));
            } else {
                // Otherwise, return the entries as strings
                return entries;
            }
        }

        // Main function to determine which parsing function to use
        function parseEntries(inputString) {
            if (inputString.includes('{') && inputString.includes('}')) {
                return parseJsonEntries(inputString);
            } else {
                return parseSimpleEntries(inputString);
            }
        }

        // nandle publish button 
        function handle_publish(){

            var metadata_obj = JSON.parse(sessionStorage.getItem("metadata"));
            var user_obj = JSON.parse(sessionStorage.getItem("user"));

            let data={"datasets":[]}
            let i = 0;
            
            while (document.getElementById(`checkbox${i}`)) {
                let checkbox = document.getElementById(`checkbox${i}`);
                if (checkbox.checked) {
                    data["datasets"].push(metadata_obj[i]["payload"]);
                }
                i++;
            }

            if (data["datasets"].length == 0){
                showPopup('warning','No datasets selected!');
                return
            }

            if (user_obj == null){
                showPopup('login');
            }else{

                data["user"]=user_obj;
                publish(data)

            }
        }

        // publsh to eu portal through api
        function publish(data){

            let api=JSON.parse(getCookie("api"))

            // Make a POST request to the Node.js endpoint
            $.ajax({
				url: 'http://'+api['ip']+':'+api['port'].toString()+'/api/publish_eu_portal',
				method: 'POST',
				data: JSON.stringify(data),
				headers: {
					'Content-Type': 'application/json'
				},
				success: function (data) {
                    successful_response(data)
				},
				error: function (jqXHR, textStatus, errorThrown) {
					if (jqXHR.status==422){
                        showPopup('warning','API is down!');
                    }
                }
			});
        }

        function successful_response(data){
            
            document.getElementById("main-review-page").style.display= "none";
            document.getElementById("review-metadata-button").style.display= "none";

            const main_div = document.getElementById("main")

            const response_container= document.createElement("div");
            response_container.className="main-container"

            // Create the response-wrapper div
            const responseWrapper = document.createElement('div');
            responseWrapper.className = 'response-wrapper';

            // Create the response div
            const responseDiv = document.createElement('div');
            responseDiv.className = 'response';

            // Create the response-message div
            const responseMessage = document.createElement('div');
            responseMessage.className = 'response-message';
            let inntest="The metadata have been published to the AI on Demand platform. This ensures that users can easily locate and utilize the dataset/datasets for their AI-related projects and research.<br>";
            inntest+="<br><br>";
            let ids=[];
            if (data.length>1){
                data.forEach((element) => {
                    ids.push(element["identifier"])
                    inntest += "Dataset Identifier: "+element["identifier"]+" ("+element["status"]+").<br>";
                });
            }else{                
                inntest += "Dataset Identifier: "+data[0]["identifier"]+" ("+data[0]["status"]+").<br>";
                ids.push(data[0]["identifier"])
            }
            responseMessage.innerHTML = inntest;

            // save ids to session cookie
            sessionStorage.setItem("dt_ids",JSON.stringify(ids));

            // Create the response button
            const responseButton = document.createElement('button');
            responseButton.className = 'response-button';
            responseButton.textContent = 'Fetch from AIoD';
            responseButton.onclick = function() {
                fetch_datasets();
            };

            // Create the json-display div
            const jsonDisplay = document.createElement('div');
            jsonDisplay.id = 'json-display';
            jsonDisplay.className = 'json-container';

            // Append the message and button to the response div
            responseDiv.appendChild(responseMessage);
            responseDiv.appendChild(responseButton);

            // Append the response div and json-display div to the response-wrapper div
            responseWrapper.appendChild(responseDiv);
            responseWrapper.appendChild(jsonDisplay);

            response_container.appendChild(responseWrapper)
            main_div.appendChild(response_container)
        
        }

        function fetch_datasets(){

            let ids = JSON.parse(sessionStorage.getItem("dt_ids"));

            let api=JSON.parse(getCookie("api"))

            // Make a POST request to the Node.js endpoint
            $.ajax({
				url: 'http://'+api['ip']+':'+api['port'].toString()+'/api/datasets_metadata',
				method: 'POST',
                data: JSON.stringify({"datasets":ids}),
				headers: {
					'Content-Type': 'application/json'
				},
				success: function (data) {
                    populateJson(data)
				},
				error: function (jqXHR, textStatus, errorThrown) {
                    showPopup('warning','API is down!');
				}
			});
        }

        function populateJson(data){
            
            data["response"].forEach((item) => {
                const jsonString = JSON.stringify(item, null, 4);
                const jsonDisplayDiv = document.getElementById('json-display');

                const jsontemp= document.createElement("div");
                jsontemp.className="json-container-2"
                jsontemp.innerHTML += syntaxHighlight(jsonString);
                jsonDisplayDiv.appendChild(jsontemp)
            });

        }

        // Function to syntax highlight JSON
        function syntaxHighlight(json) {
            json = json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
            return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|true|false|null|\b\d+\b)/g, function (match) {
                let cls = 'json-number';
                if (/^"/.test(match)) {
                    if (/:$/.test(match)) {
                        cls = 'json-key';
                    } else {
                        cls = 'json-string';
                    }
                } else if (/true|false/.test(match)) {
                    cls = 'json-boolean';
                } else if (/null/.test(match)) {
                    cls = 'json-null';
                }
                return '<span class="' + cls + '">' + match + '</span>';
            });
        }

        // function to show the popup
        function showPopup(type, text) {
                const popup = document.getElementById('popup');
                const overlay = document.getElementById('popupOverlay');
                const content = document.getElementById('popupContent');
                const closeBtn = document.getElementById('popupClose');
                
                let htmlContent = '';

                if (type === 'login') {
                    htmlContent = `
                        <div class="login-wrapper">
                            <img src="images/logo-aiod.svg" alt="Logo">
                            
                        </div>                        
                        <input type="text" class="popup-input" placeholder="Username" id="username">
                        <input type="password" class="popup-input" placeholder="Password" id="password">
                        <button class="popup-button" onclick="submitLogin()">Login</button>
                    `;
                } else if (type === 'warning') {
                    htmlContent = `
                        <div class="popup-title">Warning</div>
                        <div>`+text+`</div>
                    `;
                }

                content.innerHTML = htmlContent;

                popup.style.display = 'block';
                overlay.style.display = 'block';

                closeBtn.onclick = function() {
                    popup.style.display = 'none';
                    overlay.style.display = 'none';
                }

                overlay.onclick = function() {
                    popup.style.display = 'none';
                    overlay.style.display = 'none';
                }
            }

        // function for login button click
        function submitLogin() {
            const username = document.getElementById('username').value;
            const password = document.getElementById('password').value;

            user={
                "username": username,
                "password": password
            }

            let api=JSON.parse(getCookie("api"))

            // Make a POST request to the Node.js endpoint
            $.ajax({
				url: 'http://'+api['ip']+':'+api['port'].toString()+'/api/login_eu_portal',
				method: 'POST',
				data: JSON.stringify(user),
				headers: {
					'Content-Type': 'application/json'
				},
				success: function (data) {
                    document.getElementById("login-lock").style.visibility="hidden";
                    document.getElementById('popup').style.display = 'none';
                    document.getElementById('popupOverlay').style.display = 'none';
                    sessionStorage.setItem("user",JSON.stringify(data));
				},
				error: function (jqXHR, textStatus, errorThrown) {
					if (jqXHR.status==422){
                        showPopup('warning','User not found!');
                    }else{
                        showPopup('warning','Authentication server is down.');
                    }
				}
			});
        }

    </script>



</body>
</html>
